#property copyright "Copyright Shimodax"
#property link      "http://www.strategybuilderfx.com"

#property indicator_chart_window

extern int LocalTimeZone = 0;
extern int DestTimeZone = 0;
extern int LineStyle = 2;
extern int LineThickness = 1;
extern bool ShowComment = FALSE;
extern bool ShowHighLowOpen = TRUE;
extern bool ShowSweetSpots = FALSE;
extern bool ShowPivots = TRUE;
extern bool ShowMidPitvot = FALSE;
extern bool ShowFibos = FALSE;
extern bool ShowCamarilla = FALSE;
extern bool ShowLevelPrices = TRUE;
extern int BarForLabels = 10;
extern bool DebugLogger = FALSE;
int gi_unused_132 = 0;
int gi_unused_136 = 24;
int gi_140;
int g_datetime_144 = 0;
int g_timeframe_148 = 0;

int init() {
   deinit();
   if (Ask > 10.0) gi_140 = 2;
   else gi_140 = 4;
   Print("Period= ", Period());
   return (0);
}

int deinit() {
   string l_name_16;
   int l_objs_total_0 = ObjectsTotal();
   for (int l_objs_total_12 = l_objs_total_0; l_objs_total_12 >= 0; l_objs_total_12--) {
      l_name_16 = ObjectName(l_objs_total_12);
      if (StringSubstr(l_name_16, 0, 7) == "[PIVOT]") ObjectDelete(l_name_16);
   }
   string l_var_name_4 = Symbol() + "st";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "p";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "r1";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "r2";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "r3";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "s1";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "s2";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "s3";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "yh";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "to";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "yl";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "ds1";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "ds2";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "flm618";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "flm382";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "flp382";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "flp5";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "fhm382";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "fhp382";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "fhp618";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "h3";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "h4";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "l3";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "l4";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "mr3";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "mr2";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "mr1";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "ms1";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "ms2";
   GlobalVariableDel(l_var_name_4);
   l_var_name_4 = Symbol() + "ms3";
   GlobalVariableDel(l_var_name_4);
   return (0);
}

int start() {
   int li_180;
   int li_184;
   double ld_188;
   double ld_196;
   double ld_204;
   double ld_212;
   double ld_220;
   double ld_228;
   string ls_236;
   datetime l_time_0 = 0;
   datetime l_time_4 = 0;
   double ld_8 = 0;
   double ld_16 = 0;
   double l_open_24 = 0;
   double ld_32 = 0;
   double l_open_40 = 0;
   double ld_48 = 0;
   double l_close_56 = 0;
   int li_64 = 0;
   int li_68 = 0;
   int li_72 = 0;
 //  if (TimeCurrent() - g_datetime_144 < 60 && Period() == g_timeframe_148) return (0);
   g_timeframe_148 = Period();
   g_datetime_144 = TimeCurrent();
   if (Period() > PERIOD_D1) {
      Alert("Error - Chart period is greater than 1 day.");
      return (-1);
   }
   if (DebugLogger) {
      Print("Local time current bar:", TimeToStr(Time[0]));
      Print("Dest  time current bar: ", TimeToStr(Time[0] - 3600 * (LocalTimeZone - DestTimeZone)), ", tzdiff= ", LocalTimeZone - DestTimeZone);
   }
   ComputeDayIndices(LocalTimeZone, DestTimeZone, li_64, li_68, li_72);
   l_time_0 = Time[li_64];
   string l_var_name_76 = Symbol() + "st";
   double l_time_84 = l_time_0;
   GlobalVariableSet(l_var_name_76, l_time_84);
   l_time_4 = Time[li_68];
   ld_32 = -99999;
   ld_48 = 99999;
   for (int li_92 = li_68; li_92 >= li_72; li_92--) {
      if (l_open_40 == 0.0) l_open_40 = Open[li_92];
      ld_32 = MathMax(High[li_92], ld_32);
      ld_48 = MathMin(Low[li_92], ld_48);
      l_close_56 = Close[li_92];
   }
   l_open_24 = Open[li_64];
   ld_8 = -99999;
   ld_16 = 99999;
   for (int li_96 = li_64; li_96 >= 0; li_96--) {
      ld_8 = MathMax(ld_8, High[li_96]);
      ld_16 = MathMin(ld_16, Low[li_96]);
   }
   double ld_100 = (ld_32 + ld_48 + l_close_56) / 3.0;
   SetTimeLine("YesterdayStart", "yesterday", li_68, CadetBlue, ld_100 - 4.0 * Point);
   SetTimeLine("YesterdayEnd", "today", li_64, CadetBlue, ld_100 - 4.0 * Point);
   if (DebugLogger) Print("Timezoned values: yo= ", l_open_40, ", yc =", l_close_56, ", yhigh= ", ld_32, ", ylow= ", ld_48, ", to= ", l_open_24);
   double ld_124 = ld_8 - ld_16;
   double ld_116 = ld_32 - ld_48;
   double ld_108 = (ld_32 + ld_48 + l_close_56) / 3.0;
   ld_108 = NormalizeDouble(ld_108, gi_140);
   l_var_name_76 = Symbol() + "p";
   l_time_84 = ld_108;
   GlobalVariableSet(l_var_name_76, l_time_84);
   double ld_132 = 2.0 * ld_108 - ld_48;
   ld_132 = NormalizeDouble(ld_132, gi_140);
   l_var_name_76 = Symbol() + "r1";
   l_time_84 = ld_132;
   GlobalVariableSet(l_var_name_76, l_time_84);
   double ld_140 = ld_108 + (ld_32 - ld_48);
   ld_140 = NormalizeDouble(ld_140, gi_140);
   l_var_name_76 = Symbol() + "r2";
   l_time_84 = ld_140;
   GlobalVariableSet(l_var_name_76, l_time_84);
   double ld_148 = 2.0 * ld_108 + (ld_32 - 2.0 * ld_48);
   ld_148 = NormalizeDouble(ld_148, gi_140);
   l_var_name_76 = Symbol() + "r3";
   l_time_84 = ld_148;
   GlobalVariableSet(l_var_name_76, l_time_84);
   double ld_156 = 2.0 * ld_108 - ld_32;
   ld_156 = NormalizeDouble(ld_156, gi_140);
   l_var_name_76 = Symbol() + "s1";
   l_time_84 = ld_156;
   GlobalVariableSet(l_var_name_76, l_time_84);
   double ld_164 = ld_108 - (ld_32 - ld_48);
   ld_164 = NormalizeDouble(ld_164, gi_140);
   l_var_name_76 = Symbol() + "s2";
   l_time_84 = ld_164;
   GlobalVariableSet(l_var_name_76, l_time_84);
   double ld_172 = 2.0 * ld_108 - (2.0 * ld_32 - ld_48);
   ld_172 = NormalizeDouble(ld_172, gi_140);
   l_var_name_76 = Symbol() + "s3";
   l_time_84 = ld_172;
   GlobalVariableSet(l_var_name_76, l_time_84);
   if (ShowHighLowOpen) {
      SetLevel("Y\'s High", ld_32, Goldenrod, LineStyle, LineThickness, l_time_4);
      SetLevel("T\'s Open", l_open_24, Goldenrod, LineStyle, LineThickness, l_time_0);
      SetLevel("Y\'s Low", ld_48, Goldenrod, LineStyle, LineThickness, l_time_4);
      l_var_name_76 = Symbol() + "yh";
      l_time_84 = ld_32;
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "to";
      l_time_84 = l_open_24;
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "yl";
      l_time_84 = ld_48;
      GlobalVariableSet(l_var_name_76, l_time_84);
   }
   if (ShowSweetSpots) {
      li_180 = Bid / Point;
      li_180 -= li_180 % 50;
      li_184 = li_180 + 50;
      ld_188 = li_180 * Point;
      ld_196 = li_184 * Point;
      SetLevel(DoubleToStr(ld_188, Digits), ld_188, Gold, LineStyle, LineThickness, Time[10]);
      SetLevel(DoubleToStr(ld_196, Digits), ld_196, Gold, LineStyle, LineThickness, Time[10]);
      l_var_name_76 = Symbol() + "ds1";
      l_time_84 = ld_188;
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "ds2";
      l_time_84 = ld_196;
      GlobalVariableSet(l_var_name_76, l_time_84);
   }
   if (ShowPivots == TRUE) {
      SetLevel("R1", ld_132, LightSeaGreen, LineStyle, LineThickness, l_time_0);
      SetLevel("R2", ld_140, LightSeaGreen, LineStyle, LineThickness, l_time_0);
      SetLevel("R3", ld_148, LightSeaGreen, LineStyle, LineThickness, l_time_0);
      SetLevel("Pivot", ld_108, Fuchsia, LineStyle, LineThickness, l_time_0);
      SetLevel("S1", ld_156, OrangeRed, LineStyle, LineThickness, l_time_0);
      SetLevel("S2", ld_164, OrangeRed, LineStyle, LineThickness, l_time_0);
      SetLevel("S3", ld_172, OrangeRed, LineStyle, LineThickness, l_time_0);
   }
   if (ShowFibos) {
      SetLevel("Low - 61.8%", ld_48 - 0.618 * ld_116, Yellow, LineStyle, LineThickness, l_time_0);
      SetLevel("Low - 38.2%", ld_48 - ld_116 / 2.0, Yellow, LineStyle, LineThickness, l_time_0);
      SetLevel("Low + 38.2%", ld_48 + ld_116 / 2.0, Yellow, LineStyle, LineThickness, l_time_0);
      SetLevel("LowHigh 50%", ld_48 + ld_116 / 2.0, Yellow, LineStyle, LineThickness, l_time_0);
      SetLevel("High - 38.2%", ld_32 - ld_116 / 2.0, Yellow, LineStyle, LineThickness, l_time_0);
      SetLevel("High + 38.2%", ld_32 + ld_116 / 2.0, Yellow, LineStyle, LineThickness, l_time_0);
      SetLevel("High + 61.8%", ld_32 + 0.618 * ld_116, Yellow, LineStyle, LineThickness, l_time_0);
      l_var_name_76 = Symbol() + "flm618";
      l_time_84 = ld_48 - 0.618 * ld_116;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "flm382";
      l_time_84 = ld_48 - ld_116 / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "flp382";
      l_time_84 = ld_48 + ld_116 / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "flp5";
      l_time_84 = ld_48 + ld_116 / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "fhm382";
      l_time_84 = ld_32 - ld_116 / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "fhp382";
      l_time_84 = ld_32 + ld_116 / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "fhp618";
      l_time_84 = ld_32 + 0.618 * ld_116;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
   }
   if (ShowCamarilla == TRUE) {
      ld_204 = 0.55 * ld_116 + l_close_56;
      ld_212 = 0.27 * ld_116 + l_close_56;
      ld_228 = l_close_56 - 0.27 * ld_116;
      ld_220 = l_close_56 - 0.55 * ld_116;
      SetLevel("H3", ld_212, Khaki, LineStyle, LineThickness, l_time_0);
      SetLevel("H4", ld_204, Khaki, LineStyle, LineThickness, l_time_0);
      SetLevel("L3", ld_228, Khaki, LineStyle, LineThickness, l_time_0);
      SetLevel("L4", ld_220, Khaki, LineStyle, LineThickness, l_time_0);
      l_var_name_76 = Symbol() + "h3";
      l_time_84 = ld_212;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "h4";
      l_time_84 = ld_204;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "l3";
      l_time_84 = ld_228;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "l4";
      l_time_84 = ld_220;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
   }
   if (ShowMidPitvot == TRUE) {
      SetLevel("MR3", (ld_140 + ld_148) / 2.0, Green, LineStyle, LineThickness, l_time_0);
      SetLevel("MR2", (ld_132 + ld_140) / 2.0, Green, LineStyle, LineThickness, l_time_0);
      SetLevel("MR1", (ld_108 + ld_132) / 2.0, Green, LineStyle, LineThickness, l_time_0);
      SetLevel("MS1", (ld_108 + ld_156) / 2.0, Green, LineStyle, LineThickness, l_time_0);
      SetLevel("MS2", (ld_156 + ld_164) / 2.0, Green, LineStyle, LineThickness, l_time_0);
      SetLevel("MS3", (ld_164 + ld_172) / 2.0, Green, LineStyle, LineThickness, l_time_0);
      l_var_name_76 = Symbol() + "mr3";
      l_time_84 = (ld_140 + ld_148) / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "mr2";
      l_time_84 = (ld_132 + ld_140) / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "mr1";
      l_time_84 = (ld_108 + ld_132) / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "ms1";
      l_time_84 = (ld_108 + ld_156) / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "ms2";
      l_time_84 = (ld_108 + ld_164) / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
      l_var_name_76 = Symbol() + "ms3";
      l_time_84 = (ld_108 + ld_172) / 2.0;
      l_time_84 = NormalizeDouble(l_time_84, gi_140);
      GlobalVariableSet(l_var_name_76, l_time_84);
   }
   if (ShowComment) {
      ls_236 = "";
      ls_236 = ls_236 + "-- Good luck with your trading! ---\n";
      ls_236 = ls_236 + "Range: Yesterday " + DoubleToStr(MathRound(ld_116 / Point), 0) + " pips, Today " + DoubleToStr(MathRound(ld_124 / Point), 0) + " pips" 
      + "\n";
      ls_236 = ls_236 + "Highs: Yesterday " + DoubleToStr(ld_32, Digits) + ", Today " + DoubleToStr(ld_8, Digits) 
      + "\n";
      ls_236 = ls_236 + "Lows:  Yesterday " + DoubleToStr(ld_48, Digits) + ", Today " + DoubleToStr(ld_16, Digits) 
      + "\n";
      ls_236 = ls_236 + "Close: Yesterday " + DoubleToStr(l_close_56, Digits) 
      + "\n";
      Comment(ls_236);
   }
   return (0);
}

void ComputeDayIndices(int ai_0, int ai_4, int &ai_8, int &ai_12, int &ai_16) {
   int li_52;
   int li_60;
   int li_64;
   int li_20 = ai_0 - ai_4;
   int li_24 = 3600 * li_20;
   int li_28 = 1440;
   int li_32 = li_28 / Period();
   int l_day_of_week_36 = TimeDayOfWeek(Time[0] - li_24);
   int li_40 = -1;
   ai_8 = 0;
   ai_12 = 0;
   ai_16 = 0;
   switch (l_day_of_week_36) {
   case 6:
   case 0:
      li_40 = 5;
      break;
   case 1: break;
   default:
      li_40 = l_day_of_week_36 - 1;
   }
   if (DebugLogger) {
      Print("Dayofweektoday= ", l_day_of_week_36);
      Print("Dayofweekyesterday= ", li_40);
   }
   for (int li_48 = 1; li_48 <= li_32 + 1; li_48++) {
      li_52 = Time[li_48] - li_24;
      if (TimeDayOfWeek(li_52) != l_day_of_week_36) {
         ai_8 = li_48 - 1;
         break;
      }
   }
   for (int l_count_56 = 0; l_count_56 <= li_32 * 2 + 1; l_count_56++) {
      li_60 = Time[li_48 + l_count_56] - li_24;
      if (TimeDayOfWeek(li_60) == li_40) {
         ai_16 = li_48 + l_count_56;
         break;
      }
   }
   for (l_count_56 = 1; l_count_56 <= li_32; l_count_56++) {
      li_64 = Time[ai_16 + l_count_56] - li_24;
      if (TimeDayOfWeek(li_64) != li_40) {
         ai_12 = ai_16 + l_count_56 - 1;
         break;
      }
   }
   if (DebugLogger) {
      Print("Dest time zone\'s current day starts:", TimeToStr(Time[ai_8]), " (local time), idxbar= ", ai_8);
      Print("Dest time zone\'s previous day starts:", TimeToStr(Time[ai_12]), " (local time), idxbar= ", ai_12);
      Print("Dest time zone\'s previous day ends:", TimeToStr(Time[ai_16]), " (local time), idxbar= ", ai_16);
   }
}

void SetLevel(string as_0, double a_price_8, color a_color_16, int a_style_20, int a_width_24, int a_datetime_28) {
   int li_unused_32 = Digits;
   string l_name_36 = "[PIVOT] " + as_0 + " Label";
   string l_name_44 = "[PIVOT] " + as_0 + " Line";
   if (ObjectFind(l_name_44) != 0) {
      ObjectCreate(l_name_44, OBJ_TREND, 0, a_datetime_28, a_price_8, Time[0], a_price_8);
      ObjectSet(l_name_44, OBJPROP_STYLE, a_style_20);
      ObjectSet(l_name_44, OBJPROP_COLOR, a_color_16);
      ObjectSet(l_name_44, OBJPROP_WIDTH, a_width_24);
   } else {
      ObjectMove(l_name_44, 1, Time[0], a_price_8);
      ObjectMove(l_name_44, 0, a_datetime_28, a_price_8);
   }
   if (ObjectFind(l_name_36) != 0) ObjectCreate(l_name_36, OBJ_TEXT, 0, MathMin(Time[BarForLabels], a_datetime_28 + 60 * (Period() * 2)), a_price_8);
   else ObjectMove(l_name_36, 0, MathMin(Time[BarForLabels], a_datetime_28 + 60 * (Period() * 2)), a_price_8);
   string l_text_52 = " " + as_0;
   if (ShowLevelPrices && StrToInteger(as_0) == 0) l_text_52 = l_text_52 + ": " + DoubleToStr(a_price_8, Digits);
   ObjectSetText(l_name_36, l_text_52, 8, "Arial", White);
}

void SetTimeLine(string as_0, string a_text_8, int ai_16, color a_color_20, double a_price_24) {
   string l_name_32 = "[PIVOT] " + as_0;
   int l_time_40 = Time[ai_16];
   if (ObjectFind(l_name_32) != 0) ObjectCreate(l_name_32, OBJ_TREND, 0, l_time_40, 0, l_time_40, 100);
   else {
      ObjectMove(l_name_32, 0, l_time_40, 0);
      ObjectMove(l_name_32, 1, l_time_40, 100);
   }
   ObjectSet(l_name_32, OBJPROP_STYLE, STYLE_DOT);
   ObjectSet(l_name_32, OBJPROP_COLOR, DarkGray);
   if (ObjectFind(l_name_32 + " Label") != 0) ObjectCreate(l_name_32 + " Label", OBJ_TEXT, 0, l_time_40, a_price_24);
   else ObjectMove(l_name_32 + " Label", 0, l_time_40, a_price_24);
   ObjectSetText(l_name_32 + " Label", a_text_8, 8, "Arial", a_color_20);
}
