
#property indicator_chart_window

extern bool Corner_of_Chart_RIGHT_TOP = TRUE;
extern bool Show_Price = TRUE;
extern bool Show_Xtra_Details = FALSE;
extern bool Show_Smaller_Size = FALSE;
extern int Shift_UP_DN = 0;
extern int Adjust_Side_to_side = 0;
extern color BarLabel_color = LightSteelBlue;
extern color CommentLabel_color = LightSteelBlue;
extern int MACD_Fast = 8;
extern int MACD_Slow = 21;
extern int MACD_Signal = 8;
extern int MACD_PRICE_TYPE = 0;
extern int RSI_Period = 8;
extern int RSI_PRICE_TYPE = 0;
extern int CCI_Period = 13;
extern int CCI_PRICE_TYPE = 0;
extern int STOCH_K_Period = 5;
extern int STOCH_D_Period = 3;
extern int STOCH_Slowing = 3;
extern int STOCH_MA_MODE = 1;
extern int MA_Fast = 5;
extern int MA_Slow = 7;
extern int MA_MODE = 1;
extern int MA_PRICE_TYPE = 0;

int init() {
   return (0);
}

int deinit() {
   ObjectsDeleteAll(0, OBJ_LABEL);
   return (0);
}

int start() {
   color l_color_60;
   color l_color_64;
   color l_color_68;
   int li_unused_72;
   color l_color_76;
   color l_color_80;
   color l_color_84;
   int li_unused_404;
   color l_color_440;
   color l_color_444;
   color l_color_448;
   color l_color_452;
   color l_color_456;
   color l_color_460;
   int li_unused_640;
   color l_color_644;
   color l_color_648;
   color l_color_652;
   color l_color_656;
   color l_color_660;
   color l_color_664;
   string ls_unused_748;
   color l_color_780;
   color l_color_784;
   int l_ind_counted_0 = IndicatorCounted();
   string l_text_4 = "";
   string l_text_12 = "";
   string l_text_20 = "";
   string ls_unused_28 = "";
   string l_text_36 = "";
   string l_text_44 = "";
   string l_text_52 = "";
   double l_imacd_88 = iMACD(NULL, PERIOD_M1, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_96 = iMACD(NULL, PERIOD_M1, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_104 = iMACD(NULL, PERIOD_M5, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_112 = iMACD(NULL, PERIOD_M5, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_120 = iMACD(NULL, PERIOD_M15, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_128 = iMACD(NULL, PERIOD_M15, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_136 = iMACD(NULL, PERIOD_M30, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_144 = iMACD(NULL, PERIOD_M30, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_152 = iMACD(NULL, PERIOD_H1, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_160 = iMACD(NULL, PERIOD_H1, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_168 = iMACD(NULL, PERIOD_H4, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_176 = iMACD(NULL, PERIOD_H4, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   double l_imacd_184 = iMACD(NULL, PERIOD_D1, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_MAIN, 0);
   double l_imacd_192 = iMACD(NULL, PERIOD_D1, MACD_Fast, MACD_Slow, MACD_Signal, MACD_PRICE_TYPE, MODE_SIGNAL, 0);
   if (l_imacd_88 > l_imacd_96) {
      ls_unused_28 = "-";
      li_unused_72 = 32768;
   }
   if (l_imacd_88 <= l_imacd_96) {
      ls_unused_28 = "-";
      li_unused_72 = 4678655;
   }
   if (l_imacd_88 > l_imacd_96 && l_imacd_88 > 0.0) {
      ls_unused_28 = "-";
      li_unused_72 = 65280;
   }
   if (l_imacd_88 <= l_imacd_96 && l_imacd_88 < 0.0) {
      ls_unused_28 = "-";
      li_unused_72 = 255;
   }
   if (l_imacd_104 > l_imacd_112) {
      l_text_36 = "-";
      l_color_76 = Green;
   }
   if (l_imacd_104 <= l_imacd_112) {
      l_text_36 = "-";
      l_color_76 = Tomato;
   }
   if (l_imacd_104 > l_imacd_112 && l_imacd_104 > 0.0) {
      l_text_36 = "-";
      l_color_76 = Lime;
   }
   if (l_imacd_104 <= l_imacd_112 && l_imacd_104 < 0.0) {
      l_text_36 = "-";
      l_color_76 = Red;
   }
   if (l_imacd_120 > l_imacd_128) {
      l_text_44 = "-";
      l_color_80 = Green;
   }
   if (l_imacd_120 <= l_imacd_128) {
      l_text_44 = "-";
      l_color_80 = Tomato;
   }
   if (l_imacd_120 > l_imacd_128 && l_imacd_120 > 0.0) {
      l_text_44 = "-";
      l_color_80 = Lime;
   }
   if (l_imacd_120 <= l_imacd_128 && l_imacd_120 < 0.0) {
      l_text_44 = "-";
      l_color_80 = Red;
   }
   if (l_imacd_136 > l_imacd_144) {
      l_text_52 = "-";
      l_color_84 = Green;
   }
   if (l_imacd_136 <= l_imacd_144) {
      l_text_52 = "-";
      l_color_84 = Tomato;
   }
   if (l_imacd_136 > l_imacd_144 && l_imacd_136 > 0.0) {
      l_text_52 = "-";
      l_color_84 = Lime;
   }
   if (l_imacd_136 <= l_imacd_144 && l_imacd_136 < 0.0) {
      l_text_52 = "-";
      l_color_84 = Red;
   }
   if (l_imacd_152 > l_imacd_160) {
      l_text_12 = "-";
      l_color_64 = Green;
   }
   if (l_imacd_152 <= l_imacd_160) {
      l_text_12 = "-";
      l_color_64 = Tomato;
   }
   if (l_imacd_152 > l_imacd_160 && l_imacd_152 > 0.0) {
      l_text_12 = "-";
      l_color_64 = Lime;
   }
   if (l_imacd_152 <= l_imacd_160 && l_imacd_152 < 0.0) {
      l_text_12 = "-";
      l_color_64 = Red;
   }
   if (l_imacd_168 > l_imacd_176) {
      l_text_20 = "-";
      l_color_68 = Green;
   }
   if (l_imacd_168 <= l_imacd_176) {
      l_text_20 = "-";
      l_color_68 = Tomato;
   }
   if (l_imacd_168 > l_imacd_176 && l_imacd_168 > 0.0) {
      l_text_20 = "-";
      l_color_68 = Lime;
   }
   if (l_imacd_168 <= l_imacd_176 && l_imacd_168 < 0.0) {
      l_text_20 = "-";
      l_color_68 = Red;
   }
   if (l_imacd_184 > l_imacd_192) {
      l_text_4 = "-";
      l_color_60 = Green;
   }
   if (l_imacd_184 <= l_imacd_192) {
      l_text_4 = "-";
      l_color_60 = Tomato;
   }
   if (l_imacd_184 > l_imacd_192 && l_imacd_184 > 0.0) {
      l_text_4 = "-";
      l_color_60 = Lime;
   }
   if (l_imacd_184 <= l_imacd_192 && l_imacd_184 < 0.0) {
      l_text_4 = "-";
      l_color_60 = Red;
   }
   if (Corner_of_Chart_RIGHT_TOP == 1) {
      ObjectCreate("Numbers", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Numbers", "M5 M15 M30 H1  H4  D1", 6, "Tahoma Narrow", BarLabel_color);
      ObjectSet("Numbers", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
      ObjectSet("Numbers", OBJPROP_XDISTANCE, Adjust_Side_to_side + 14);
      ObjectSet("Numbers", OBJPROP_YDISTANCE, Shift_UP_DN + 25);
   }
   if (Corner_of_Chart_RIGHT_TOP == 0) {
      ObjectCreate("Numbers", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Numbers", "D1  H4  H1 M30 M15 M5", 6, "Tahoma Narrow", BarLabel_color);
      ObjectSet("Numbers", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
      ObjectSet("Numbers", OBJPROP_XDISTANCE, Adjust_Side_to_side + 15);
      ObjectSet("Numbers", OBJPROP_YDISTANCE, Shift_UP_DN + 25);
   }
   ObjectCreate("SSignalMACDM1t", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SSignalMACDM1t", "MACD", 6, "Tahoma Narrow", BarLabel_color);
   ObjectSet("SSignalMACDM1t", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SSignalMACDM1t", OBJPROP_XDISTANCE, Adjust_Side_to_side + 105);
   ObjectSet("SSignalMACDM1t", OBJPROP_YDISTANCE, Shift_UP_DN + 35);
   ObjectCreate("SSignalMACDM5", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SSignalMACDM5", l_text_36, 35, "Tahoma Narrow", l_color_76);
   ObjectSet("SSignalMACDM5", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SSignalMACDM5", OBJPROP_XDISTANCE, Adjust_Side_to_side + 85);
   ObjectSet("SSignalMACDM5", OBJPROP_YDISTANCE, Shift_UP_DN + 10);
   ObjectCreate("SSignalMACDM15", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SSignalMACDM15", l_text_44, 35, "Tahoma Narrow", l_color_80);
   ObjectSet("SSignalMACDM15", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SSignalMACDM15", OBJPROP_XDISTANCE, Adjust_Side_to_side + 70);
   ObjectSet("SSignalMACDM15", OBJPROP_YDISTANCE, Shift_UP_DN + 10);
   ObjectCreate("SSignalMACDM30", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SSignalMACDM30", l_text_52, 35, "Tahoma Narrow", l_color_84);
   ObjectSet("SSignalMACDM30", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SSignalMACDM30", OBJPROP_XDISTANCE, Adjust_Side_to_side + 55);
   ObjectSet("SSignalMACDM30", OBJPROP_YDISTANCE, Shift_UP_DN + 10);
   ObjectCreate("SSignalMACDH1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SSignalMACDH1", l_text_12, 35, "Tahoma Narrow", l_color_64);
   ObjectSet("SSignalMACDH1", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SSignalMACDH1", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
   ObjectSet("SSignalMACDH1", OBJPROP_YDISTANCE, Shift_UP_DN + 10);
   ObjectCreate("SSignalMACDH4", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SSignalMACDH4", l_text_20, 35, "Tahoma Narrow", l_color_68);
   ObjectSet("SSignalMACDH4", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SSignalMACDH4", OBJPROP_XDISTANCE, Adjust_Side_to_side + 25);
   ObjectSet("SSignalMACDH4", OBJPROP_YDISTANCE, Shift_UP_DN + 10);
   ObjectCreate("SSignalMACDD1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SSignalMACDD1", l_text_4, 35, "Tahoma Narrow", l_color_60);
   ObjectSet("SSignalMACDD1", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SSignalMACDD1", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
   ObjectSet("SSignalMACDD1", OBJPROP_YDISTANCE, Shift_UP_DN + 10);
   double l_irsi_200 = iRSI(NULL, PERIOD_D1, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_208 = iRSI(NULL, PERIOD_H4, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_216 = iRSI(NULL, PERIOD_H1, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_224 = iRSI(NULL, PERIOD_M30, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_232 = iRSI(NULL, PERIOD_M15, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_240 = iRSI(NULL, PERIOD_M5, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_irsi_248 = iRSI(NULL, PERIOD_M1, RSI_Period, RSI_PRICE_TYPE, 0);
   double l_istochastic_256 = iStochastic(NULL, PERIOD_D1, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_264 = iStochastic(NULL, PERIOD_H4, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_272 = iStochastic(NULL, PERIOD_H1, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_280 = iStochastic(NULL, PERIOD_M30, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_288 = iStochastic(NULL, PERIOD_M15, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_296 = iStochastic(NULL, PERIOD_M5, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_istochastic_304 = iStochastic(NULL, PERIOD_M1, STOCH_K_Period, STOCH_D_Period, STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double l_icci_312 = iCCI(NULL, PERIOD_D1, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_320 = iCCI(NULL, PERIOD_H4, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_328 = iCCI(NULL, PERIOD_H1, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_336 = iCCI(NULL, PERIOD_M30, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_344 = iCCI(NULL, PERIOD_M15, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_352 = iCCI(NULL, PERIOD_M5, CCI_Period, CCI_PRICE_TYPE, 0);
   double l_icci_360 = iCCI(NULL, PERIOD_M1, CCI_Period, CCI_PRICE_TYPE, 0);
   string l_text_368 = "";
   string l_text_376 = "";
   string l_text_384 = "";
   string ls_unused_392 = "";
   string l_text_400 = "";
   string l_text_408 = "";
   string l_text_416 = "";
   string ls_unused_424 = "";
   if (l_irsi_200 > 50.0 && l_istochastic_256 > 40.0 && l_icci_312 > 0.0) {
      l_text_416 = "-";
      l_color_460 = Lime;
   }
   if (l_irsi_208 > 50.0 && l_istochastic_264 > 40.0 && l_icci_320 > 0.0) {
      l_text_400 = "-";
      l_color_456 = Lime;
   }
   if (l_irsi_216 > 50.0 && l_istochastic_272 > 40.0 && l_icci_328 > 0.0) {
      l_text_368 = "-";
      l_color_452 = Lime;
   }
   if (l_irsi_224 > 50.0 && l_istochastic_280 > 40.0 && l_icci_336 > 0.0) {
      l_text_408 = "-";
      l_color_448 = Lime;
   }
   if (l_irsi_232 > 50.0 && l_istochastic_288 > 40.0 && l_icci_344 > 0.0) {
      l_text_376 = "-";
      l_color_444 = Lime;
   }
   if (l_irsi_240 > 50.0 && l_istochastic_296 > 40.0 && l_icci_352 > 0.0) {
      l_text_384 = "-";
      l_color_440 = Lime;
   }
   if (l_irsi_248 > 50.0 && l_istochastic_304 > 40.0 && l_icci_360 > 0.0) {
      ls_unused_392 = "-";
      double ts_unused_436 = 65280;
   }
   if (l_irsi_200 < 50.0 && l_istochastic_256 < 60.0 && l_icci_312 < 0.0) {
      l_text_416 = "-";
      l_color_460 = Red;
   }
   if (l_irsi_208 < 50.0 && l_istochastic_264 < 60.0 && l_icci_320 < 0.0) {
      l_text_400 = "-";
      l_color_456 = Red;
   }
   if (l_irsi_216 < 50.0 && l_istochastic_272 < 60.0 && l_icci_328 < 0.0) {
      l_text_368 = "-";
      l_color_452 = Red;
   }
   if (l_irsi_224 < 50.0 && l_istochastic_280 < 60.0 && l_icci_336 < 0.0) {
      l_text_408 = "-";
      l_color_448 = Red;
   }
   if (l_irsi_232 < 50.0 && l_istochastic_288 < 60.0 && l_icci_344 < 0.0) {
      l_text_376 = "-";
      l_color_444 = Red;
   }
   if (l_irsi_240 < 50.0 && l_istochastic_296 < 60.0 && l_icci_352 < 0.0) {
      l_text_384 = "-";
      l_color_440 = Red;
   }
   if (l_irsi_248 < 50.0 && l_istochastic_304 < 60.0 && l_icci_360 < 0.0) {
      ls_unused_392 = "-";
      ts_unused_436 = 255;
   }
   if (l_irsi_248 < 50.0 && l_istochastic_304 > 40.0 && l_icci_360 > 0.0) {
      ls_unused_392 = "-";
      ts_unused_436 = 42495;
   }
   if (l_irsi_248 > 50.0 && l_istochastic_304 < 60.0 && l_icci_360 < 0.0) {
      ls_unused_392 = "-";
      ts_unused_436 = 42495;
   }
   if (l_irsi_248 < 50.0 && l_istochastic_304 > 40.0 && l_icci_360 < 0.0) {
      ls_unused_392 = "-";
      ts_unused_436 = 42495;
   }
   if (l_irsi_248 > 50.0 && l_istochastic_304 < 60.0 && l_icci_360 > 0.0) {
      ls_unused_392 = "-";
      ts_unused_436 = 42495;
   }
   if (l_irsi_248 > 50.0 && l_istochastic_304 > 40.0 && l_icci_360 < 0.0) {
      ls_unused_392 = "-";
      ts_unused_436 = 42495;
   }
   if (l_irsi_248 > 50.0 && l_istochastic_304 < 60.0 && l_icci_360 < 0.0) {
      ls_unused_392 = "-";
      ts_unused_436 = 42495;
   }
   if (l_irsi_240 < 50.0 && l_istochastic_296 > 40.0 && l_icci_352 > 0.0) {
      l_text_384 = "-";
      l_color_440 = Orange;
   }
   if (l_irsi_240 > 50.0 && l_istochastic_296 < 60.0 && l_icci_352 < 0.0) {
      l_text_384 = "-";
      l_color_440 = Orange;
   }
   if (l_irsi_240 < 50.0 && l_istochastic_296 > 40.0 && l_icci_352 < 0.0) {
      l_text_384 = "-";
      l_color_440 = Orange;
   }
   if (l_irsi_240 > 50.0 && l_istochastic_296 < 60.0 && l_icci_352 > 0.0) {
      l_text_384 = "-";
      l_color_440 = Orange;
   }
   if (l_irsi_240 > 50.0 && l_istochastic_296 > 40.0 && l_icci_352 < 0.0) {
      l_text_384 = "-";
      l_color_440 = Orange;
   }
   if (l_irsi_240 > 50.0 && l_istochastic_296 < 60.0 && l_icci_352 < 0.0) {
      l_text_384 = "-";
      l_color_440 = Orange;
   }
   if (l_irsi_232 < 50.0 && l_istochastic_288 > 40.0 && l_icci_344 > 0.0) {
      l_text_376 = "-";
      l_color_444 = Orange;
   }
   if (l_irsi_232 > 50.0 && l_istochastic_288 < 60.0 && l_icci_344 < 0.0) {
      l_text_376 = "-";
      l_color_444 = Orange;
   }
   if (l_irsi_232 < 50.0 && l_istochastic_288 > 40.0 && l_icci_344 < 0.0) {
      l_text_376 = "-";
      l_color_444 = Orange;
   }
   if (l_irsi_232 > 50.0 && l_istochastic_288 < 60.0 && l_icci_344 > 0.0) {
      l_text_376 = "-";
      l_color_444 = Orange;
   }
   if (l_irsi_232 > 50.0 && l_istochastic_288 > 40.0 && l_icci_344 < 0.0) {
      l_text_376 = "-";
      l_color_444 = Orange;
   }
   if (l_irsi_232 > 50.0 && l_istochastic_288 < 60.0 && l_icci_344 < 0.0) {
      l_text_376 = "-";
      l_color_444 = Orange;
   }
   if (l_irsi_224 < 50.0 && l_istochastic_280 > 40.0 && l_icci_336 > 0.0) {
      l_text_408 = "-";
      l_color_448 = Orange;
   }
   if (l_irsi_224 > 50.0 && l_istochastic_280 < 60.0 && l_icci_336 < 0.0) {
      l_text_408 = "-";
      l_color_448 = Orange;
   }
   if (l_irsi_224 < 50.0 && l_istochastic_280 > 40.0 && l_icci_336 < 0.0) {
      l_text_408 = "-";
      l_color_448 = Orange;
   }
   if (l_irsi_224 > 50.0 && l_istochastic_280 < 60.0 && l_icci_336 > 0.0) {
      l_text_408 = "-";
      l_color_448 = Orange;
   }
   if (l_irsi_224 > 50.0 && l_istochastic_280 > 40.0 && l_icci_336 < 0.0) {
      l_text_408 = "-";
      l_color_448 = Orange;
   }
   if (l_irsi_224 > 50.0 && l_istochastic_280 < 60.0 && l_icci_336 < 0.0) {
      l_text_408 = "-";
      l_color_448 = Orange;
   }
   if (l_irsi_216 < 50.0 && l_istochastic_272 > 40.0 && l_icci_328 > 0.0) {
      l_text_368 = "-";
      l_color_452 = Orange;
   }
   if (l_irsi_216 > 50.0 && l_istochastic_272 < 60.0 && l_icci_328 < 0.0) {
      l_text_368 = "-";
      l_color_452 = Orange;
   }
   if (l_irsi_216 < 50.0 && l_istochastic_272 > 40.0 && l_icci_328 < 0.0) {
      l_text_368 = "-";
      l_color_452 = Orange;
   }
   if (l_irsi_216 > 50.0 && l_istochastic_272 < 60.0 && l_icci_328 > 0.0) {
      l_text_368 = "-";
      l_color_452 = Orange;
   }
   if (l_irsi_216 > 50.0 && l_istochastic_272 > 40.0 && l_icci_328 < 0.0) {
      l_text_368 = "-";
      l_color_452 = Orange;
   }
   if (l_irsi_216 > 50.0 && l_istochastic_272 < 60.0 && l_icci_328 < 0.0) {
      l_text_368 = "-";
      l_color_452 = Orange;
   }
   if (l_irsi_208 < 50.0 && l_istochastic_264 > 40.0 && l_icci_320 > 0.0) {
      l_text_400 = "-";
      l_color_456 = Orange;
   }
   if (l_irsi_208 > 50.0 && l_istochastic_264 < 60.0 && l_icci_320 < 0.0) {
      l_text_400 = "-";
      l_color_456 = Orange;
   }
   if (l_irsi_208 < 50.0 && l_istochastic_264 > 40.0 && l_icci_320 < 0.0) {
      l_text_400 = "-";
      l_color_456 = Orange;
   }
   if (l_irsi_208 > 50.0 && l_istochastic_264 < 60.0 && l_icci_320 > 0.0) {
      l_text_400 = "-";
      l_color_456 = Orange;
   }
   if (l_irsi_208 > 50.0 && l_istochastic_264 > 40.0 && l_icci_320 < 0.0) {
      l_text_400 = "-";
      l_color_456 = Orange;
   }
   if (l_irsi_208 > 50.0 && l_istochastic_264 < 60.0 && l_icci_320 < 0.0) {
      l_text_400 = "-";
      l_color_456 = Orange;
   }
   if (l_irsi_200 < 50.0 && l_istochastic_256 > 40.0 && l_icci_312 > 0.0) {
      l_text_416 = "-";
      l_color_460 = Orange;
   }
   if (l_irsi_200 > 50.0 && l_istochastic_256 < 60.0 && l_icci_312 < 0.0) {
      l_text_416 = "-";
      l_color_460 = Orange;
   }
   if (l_irsi_200 < 50.0 && l_istochastic_256 > 40.0 && l_icci_312 < 0.0) {
      l_text_416 = "-";
      l_color_460 = Orange;
   }
   if (l_irsi_200 > 50.0 && l_istochastic_256 < 60.0 && l_icci_312 > 0.0) {
      l_text_416 = "-";
      l_color_460 = Orange;
   }
   if (l_irsi_200 > 50.0 && l_istochastic_256 > 40.0 && l_icci_312 < 0.0) {
      l_text_416 = "-";
      l_color_460 = Orange;
   }
   if (l_irsi_200 > 50.0 && l_istochastic_256 < 60.0 && l_icci_312 < 0.0) {
      l_text_416 = "-";
      l_color_460 = Orange;
   }
   ObjectCreate("SignalSTRM1t", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalSTRM1t", "STR", 6, "Tahoma Narrow", BarLabel_color);
   ObjectSet("SignalSTRM1t", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalSTRM1t", OBJPROP_XDISTANCE, Adjust_Side_to_side + 105);
   ObjectSet("SignalSTRM1t", OBJPROP_YDISTANCE, Shift_UP_DN + 43);
   ObjectCreate("SignalSTRM5", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalSTRM5", l_text_384, 35, "Tahoma Narrow", l_color_440);
   ObjectSet("SignalSTRM5", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalSTRM5", OBJPROP_XDISTANCE, Adjust_Side_to_side + 85);
   ObjectSet("SignalSTRM5", OBJPROP_YDISTANCE, Shift_UP_DN + 18);
   ObjectCreate("SignalSTRM15", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalSTRM15", l_text_376, 35, "Tahoma Narrow", l_color_444);
   ObjectSet("SignalSTRM15", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalSTRM15", OBJPROP_XDISTANCE, Adjust_Side_to_side + 70);
   ObjectSet("SignalSTRM15", OBJPROP_YDISTANCE, Shift_UP_DN + 18);
   ObjectCreate("SignalSTRM30", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalSTRM30", l_text_408, 35, "Tahoma Narrow", l_color_448);
   ObjectSet("SignalSTRM30", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalSTRM30", OBJPROP_XDISTANCE, Adjust_Side_to_side + 55);
   ObjectSet("SignalSTRM30", OBJPROP_YDISTANCE, Shift_UP_DN + 18);
   ObjectCreate("SignalSTRM60", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalSTRM60", l_text_368, 35, "Tahoma Narrow", l_color_452);
   ObjectSet("SignalSTRM60", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalSTRM60", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
   ObjectSet("SignalSTRM60", OBJPROP_YDISTANCE, Shift_UP_DN + 18);
   ObjectCreate("SignalSTRM240", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalSTRM240", l_text_400, 35, "Tahoma Narrow", l_color_456);
   ObjectSet("SignalSTRM240", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalSTRM240", OBJPROP_XDISTANCE, Adjust_Side_to_side + 25);
   ObjectSet("SignalSTRM240", OBJPROP_YDISTANCE, Shift_UP_DN + 18);
   ObjectCreate("SignalSTRM1440", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalSTRM1440", l_text_416, 35, "Tahoma Narrow", l_color_460);
   ObjectSet("SignalSTRM1440", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalSTRM1440", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
   ObjectSet("SignalSTRM1440", OBJPROP_YDISTANCE, Shift_UP_DN + 18);
   double l_ima_464 = iMA(Symbol(), PERIOD_M1, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_472 = iMA(Symbol(), PERIOD_M1, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_480 = iMA(Symbol(), PERIOD_M5, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_488 = iMA(Symbol(), PERIOD_M5, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_496 = iMA(Symbol(), PERIOD_M15, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_504 = iMA(Symbol(), PERIOD_M15, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_512 = iMA(Symbol(), PERIOD_M30, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_520 = iMA(Symbol(), PERIOD_M30, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_528 = iMA(Symbol(), PERIOD_H1, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_536 = iMA(Symbol(), PERIOD_H1, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_544 = iMA(Symbol(), PERIOD_H4, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_552 = iMA(Symbol(), PERIOD_H4, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_560 = iMA(Symbol(), PERIOD_D1, MA_Fast, 0, MA_MODE, MA_PRICE_TYPE, 0);
   double l_ima_568 = iMA(Symbol(), PERIOD_D1, MA_Slow, 0, MA_MODE, MA_PRICE_TYPE, 0);
   string ls_unused_576 = "";
   string l_text_584 = "";
   string l_text_592 = "";
   string l_text_600 = "";
   string l_text_608 = "";
   string l_text_616 = "";
   string l_text_624 = "";
   if (l_ima_464 > l_ima_472) {
      ls_unused_576 = "-";
      li_unused_640 = 65280;
   }
   if (l_ima_464 <= l_ima_472) {
      ls_unused_576 = "-";
      li_unused_640 = 255;
   }
   if (l_ima_480 > l_ima_488) {
      l_text_584 = "-";
      l_color_644 = Lime;
   }
   if (l_ima_480 <= l_ima_488) {
      l_text_584 = "-";
      l_color_644 = Red;
   }
   if (l_ima_496 > l_ima_504) {
      l_text_592 = "-";
      l_color_648 = Lime;
   }
   if (l_ima_496 <= l_ima_504) {
      l_text_592 = "-";
      l_color_648 = Red;
   }
   if (l_ima_512 > l_ima_520) {
      l_text_600 = "-";
      l_color_652 = Lime;
   }
   if (l_ima_512 <= l_ima_520) {
      l_text_600 = "-";
      l_color_652 = Red;
   }
   if (l_ima_528 > l_ima_536) {
      l_text_608 = "-";
      l_color_656 = Lime;
   }
   if (l_ima_528 <= l_ima_536) {
      l_text_608 = "-";
      l_color_656 = Red;
   }
   if (l_ima_544 > l_ima_552) {
      l_text_616 = "-";
      l_color_660 = Lime;
   }
   if (l_ima_544 <= l_ima_552) {
      l_text_616 = "-";
      l_color_660 = Red;
   }
   if (l_ima_560 > l_ima_568) {
      l_text_624 = "-";
      l_color_664 = Lime;
   }
   if (l_ima_560 <= l_ima_568) {
      l_text_624 = "-";
      l_color_664 = Red;
   }
   ObjectCreate("SignalEMAM1t", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalEMAM1t", "EMA", 6, "Tahoma Narrow", BarLabel_color);
   ObjectSet("SignalEMAM1t", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalEMAM1t", OBJPROP_XDISTANCE, Adjust_Side_to_side + 105);
   ObjectSet("SignalEMAM1t", OBJPROP_YDISTANCE, Shift_UP_DN + 51);
   ObjectCreate("SignalEMAM5", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalEMAM5", l_text_584, 35, "Tahoma Narrow", l_color_644);
   ObjectSet("SignalEMAM5", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalEMAM5", OBJPROP_XDISTANCE, Adjust_Side_to_side + 85);
   ObjectSet("SignalEMAM5", OBJPROP_YDISTANCE, Shift_UP_DN + 26);
   ObjectCreate("SignalEMAM15", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalEMAM15", l_text_592, 35, "Tahoma Narrow", l_color_648);
   ObjectSet("SignalEMAM15", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalEMAM15", OBJPROP_XDISTANCE, Adjust_Side_to_side + 70);
   ObjectSet("SignalEMAM15", OBJPROP_YDISTANCE, Shift_UP_DN + 26);
   ObjectCreate("SignalEMAM30", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalEMAM30", l_text_600, 35, "Tahoma Narrow", l_color_652);
   ObjectSet("SignalEMAM30", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalEMAM30", OBJPROP_XDISTANCE, Adjust_Side_to_side + 55);
   ObjectSet("SignalEMAM30", OBJPROP_YDISTANCE, Shift_UP_DN + 26);
   ObjectCreate("SignalEMAM60", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalEMAM60", l_text_608, 35, "Tahoma Narrow", l_color_656);
   ObjectSet("SignalEMAM60", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalEMAM60", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
   ObjectSet("SignalEMAM60", OBJPROP_YDISTANCE, Shift_UP_DN + 26);
   ObjectCreate("SignalEMAM240", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalEMAM240", l_text_616, 35, "Tahoma Narrow", l_color_660);
   ObjectSet("SignalEMAM240", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalEMAM240", OBJPROP_XDISTANCE, Adjust_Side_to_side + 25);
   ObjectSet("SignalEMAM240", OBJPROP_YDISTANCE, Shift_UP_DN + 26);
   ObjectCreate("SignalEMAM1440", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalEMAM1440", l_text_624, 35, "Tahoma Narrow", l_color_664);
   ObjectSet("SignalEMAM1440", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("SignalEMAM1440", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
   ObjectSet("SignalEMAM1440", OBJPROP_YDISTANCE, Shift_UP_DN + 26);
   double l_ima_668 = iMA(Symbol(), 0, 1, 0, MODE_EMA, PRICE_CLOSE, 0);
   string l_dbl2str_632 = DoubleToStr(l_ima_668, Digits);
   if (Show_Smaller_Size == FALSE) {
      if (Show_Price == TRUE) {
         ObjectCreate("Signalprice", OBJ_LABEL, 0, 0, 0);
         ObjectSetText("Signalprice", "" + l_dbl2str_632 + "", 22, "Tahoma", l_color_448);
         ObjectSet("Signalprice", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
         ObjectSet("Signalprice", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
         ObjectSet("Signalprice", OBJPROP_YDISTANCE, Shift_UP_DN + 58);
      }
   }
   if (Show_Smaller_Size == TRUE) {
      if (Show_Price == TRUE) {
         ObjectCreate("Signalprice", OBJ_LABEL, 0, 0, 0);
         ObjectSetText("Signalprice", "" + l_dbl2str_632 + "", 15, "Tahoma", l_color_448);
         ObjectSet("Signalprice", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
         ObjectSet("Signalprice", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
         ObjectSet("Signalprice", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
      }
   }
   int li_676 = 0;
   int li_680 = 0;
   int li_684 = 0;
   int li_688 = 0;
   int li_692 = 0;
   int li_696 = 0;
   li_676 = (iHigh(NULL, PERIOD_D1, 1) - iLow(NULL, PERIOD_D1, 1)) / Point;
   for (li_696 = 1; li_696 <= 5; li_696++) li_680 = li_680 + (iHigh(NULL, PERIOD_D1, li_696) - iLow(NULL, PERIOD_D1, li_696)) / Point;
   for (li_696 = 1; li_696 <= 10; li_696++) li_684 = li_684 + (iHigh(NULL, PERIOD_D1, li_696) - iLow(NULL, PERIOD_D1, li_696)) / Point;
   for (li_696 = 1; li_696 <= 20; li_696++) li_688 = li_688 + (iHigh(NULL, PERIOD_D1, li_696) - iLow(NULL, PERIOD_D1, li_696)) / Point;
   li_680 /= 5;
   li_684 /= 10;
   li_688 /= 20;
   li_692 = (li_676 + li_680 + li_684 + li_688) / 4;
   string ls_unused_700 = "";
   string ls_unused_708 = "";
   string l_dbl2str_716 = "";
   string l_dbl2str_724 = "";
   string l_dbl2str_732 = "";
   string l_dbl2str_740 = "";
   string ls_unused_756 = "";
   string ls_unused_764 = "";
   string ls_772 = "";
   double l_iopen_788 = iOpen(NULL, PERIOD_D1, 0);
   double l_iclose_796 = iClose(NULL, PERIOD_D1, 0);
   double ld_804 = (Ask - Bid) / Point;
   double l_ihigh_812 = iHigh(NULL, PERIOD_D1, 0);
   double l_ilow_820 = iLow(NULL, PERIOD_D1, 0);
   l_dbl2str_724 = DoubleToStr((l_iclose_796 - l_iopen_788) / Point, 0);
   l_dbl2str_716 = DoubleToStr(ld_804, Digits - 4);
   l_dbl2str_732 = DoubleToStr(li_692, Digits - 4);
   ls_772 = (iHigh(NULL, PERIOD_D1, 1) - iLow(NULL, PERIOD_D1, 1)) / Point;
   l_dbl2str_740 = DoubleToStr((l_ihigh_812 - l_ilow_820) / Point, 0);
   if (l_iclose_796 >= l_iopen_788) {
      ls_unused_756 = "-";
      l_color_780 = Lime;
   }
   if (l_iclose_796 < l_iopen_788) {
      ls_unused_756 = "-";
      l_color_780 = OrangeRed;
   }
   if (l_dbl2str_732 > ls_772) {
      ls_unused_764 = "-";
      l_color_784 = Lime;
   }
   if (l_dbl2str_732 < ls_772) {
      ls_unused_764 = "-";
      l_color_784 = OrangeRed;
   }
   if (Show_Smaller_Size == FALSE) {
      if (Show_Xtra_Details == TRUE) {
         if (Show_Price == TRUE) {
            ObjectCreate("MMLEVELS7", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS7", "Spread", 10, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS7", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS7", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS7", OBJPROP_YDISTANCE, Shift_UP_DN + 100);
            ObjectCreate("MMLEVELS8", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS8", "" + l_dbl2str_716 + "", 10, "Arial Bold", Gold);
            ObjectSet("MMLEVELS8", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS8", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS8", OBJPROP_YDISTANCE, Shift_UP_DN + 100);
            ObjectCreate("MMLEVELS9", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS9", "Pips to Open", 10, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS9", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS9", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS9", OBJPROP_YDISTANCE, Shift_UP_DN + 115);
            ObjectCreate("MMLEVELS10", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS10", "" + l_dbl2str_724 + "", 10, "Arial Bold", l_color_780);
            ObjectSet("MMLEVELS10", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS10", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS10", OBJPROP_YDISTANCE, Shift_UP_DN + 115);
            ObjectCreate("MMLEVELS11", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS11", "Hi to Low", 10, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS11", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS11", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS11", OBJPROP_YDISTANCE, Shift_UP_DN + 130);
            ObjectCreate("MMLEVELS12", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS12", "" + l_dbl2str_740 + "", 10, "Arial Bold", Gold);
            ObjectSet("MMLEVELS12", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS12", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS12", OBJPROP_YDISTANCE, Shift_UP_DN + 130);
            ObjectCreate("MMLEVELS13", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS13", "Daily Av", 10, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS13", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS13", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS13", OBJPROP_YDISTANCE, Shift_UP_DN + 145);
            ObjectCreate("MMLEVELS14", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS14", "" + l_dbl2str_732 + "", 10, "Arial Bold", l_color_784);
            ObjectSet("MMLEVELS14", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS14", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS14", OBJPROP_YDISTANCE, Shift_UP_DN + 145);
         }
      }
   }
   if (Show_Smaller_Size == FALSE) {
      if (Show_Xtra_Details == TRUE) {
         if (Show_Price == FALSE) {
            ObjectCreate("MMLEVELS7", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS7", "Spread", 10, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS7", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS7", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS7", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
            ObjectCreate("MMLEVELS8", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS8", "" + l_dbl2str_716 + "", 10, "Arial Bold", Gold);
            ObjectSet("MMLEVELS8", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS8", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS8", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
            ObjectCreate("MMLEVELS9", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS9", "Pips to Open", 10, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS9", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS9", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS9", OBJPROP_YDISTANCE, Shift_UP_DN + 75);
            ObjectCreate("MMLEVELS10", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS10", "" + l_dbl2str_724 + "", 10, "Arial Bold", l_color_780);
            ObjectSet("MMLEVELS10", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS10", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS10", OBJPROP_YDISTANCE, Shift_UP_DN + 75);
            ObjectCreate("MMLEVELS11", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS11", "Hi to Low", 10, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS11", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS11", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS11", OBJPROP_YDISTANCE, Shift_UP_DN + 90);
            ObjectCreate("MMLEVELS12", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS12", "" + l_dbl2str_740 + "", 10, "Arial Bold", Gold);
            ObjectSet("MMLEVELS12", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS12", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS12", OBJPROP_YDISTANCE, Shift_UP_DN + 90);
            ObjectCreate("MMLEVELS13", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS13", "Daily Av", 10, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS13", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS13", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS13", OBJPROP_YDISTANCE, Shift_UP_DN + 105);
            ObjectCreate("MMLEVELS14", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS14", "" + l_dbl2str_732 + "", 10, "Arial Bold", l_color_784);
            ObjectSet("MMLEVELS14", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS14", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS14", OBJPROP_YDISTANCE, Shift_UP_DN + 105);
         }
      }
   }
   if (Show_Smaller_Size == TRUE) {
      if (Show_Xtra_Details == TRUE) {
         if (Show_Price == TRUE) {
            ObjectCreate("MMLEVELS7", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS7", "Spread", 8, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS7", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS7", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS7", OBJPROP_YDISTANCE, Shift_UP_DN + 80);
            ObjectCreate("MMLEVELS8", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS8", "" + l_dbl2str_716 + "", 8, "Arial Bold", Gold);
            ObjectSet("MMLEVELS8", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS8", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS8", OBJPROP_YDISTANCE, Shift_UP_DN + 80);
            ObjectCreate("MMLEVELS9", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS9", "Pips to Open", 8, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS9", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS9", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS9", OBJPROP_YDISTANCE, Shift_UP_DN + 95);
            ObjectCreate("MMLEVELS10", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS10", "" + l_dbl2str_724 + "", 8, "Arial Bold", l_color_780);
            ObjectSet("MMLEVELS10", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS10", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS10", OBJPROP_YDISTANCE, Shift_UP_DN + 95);
            ObjectCreate("MMLEVELS11", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS11", "Hi to Low", 8, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS11", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS11", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS11", OBJPROP_YDISTANCE, Shift_UP_DN + 110);
            ObjectCreate("MMLEVELS12", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS12", "" + l_dbl2str_740 + "", 8, "Arial Bold", Gold);
            ObjectSet("MMLEVELS12", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS12", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS12", OBJPROP_YDISTANCE, Shift_UP_DN + 110);
            ObjectCreate("MMLEVELS13", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS13", "Daily Av", 8, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS13", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS13", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS13", OBJPROP_YDISTANCE, Shift_UP_DN + 125);
            ObjectCreate("MMLEVELS14", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS14", "" + l_dbl2str_732 + "", 8, "Arial Bold", l_color_784);
            ObjectSet("MMLEVELS14", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS14", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS14", OBJPROP_YDISTANCE, Shift_UP_DN + 125);
         }
      }
   }
   if (Show_Smaller_Size == TRUE) {
      if (Show_Xtra_Details == TRUE) {
         if (Show_Price == FALSE) {
            ObjectCreate("MMLEVELS7", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS7", "Spread", 8, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS7", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS7", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS7", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
            ObjectCreate("MMLEVELS8", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS8", "" + l_dbl2str_716 + "", 8, "Arial Bold", Gold);
            ObjectSet("MMLEVELS8", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS8", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS8", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
            ObjectCreate("MMLEVELS9", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS9", "Pips to Open", 8, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS9", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS9", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS9", OBJPROP_YDISTANCE, Shift_UP_DN + 75);
            ObjectCreate("MMLEVELS10", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS10", "" + l_dbl2str_724 + "", 8, "Arial Bold", l_color_780);
            ObjectSet("MMLEVELS10", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS10", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS10", OBJPROP_YDISTANCE, Shift_UP_DN + 75);
            ObjectCreate("MMLEVELS11", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS11", "Hi to Low", 8, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS11", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS11", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS11", OBJPROP_YDISTANCE, Shift_UP_DN + 90);
            ObjectCreate("MMLEVELS12", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS12", "" + l_dbl2str_740 + "", 8, "Arial Bold", Gold);
            ObjectSet("MMLEVELS12", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS12", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS12", OBJPROP_YDISTANCE, Shift_UP_DN + 90);
            ObjectCreate("MMLEVELS13", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS13", "Daily Av", 8, "Arial", CommentLabel_color);
            ObjectSet("MMLEVELS13", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS13", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS13", OBJPROP_YDISTANCE, Shift_UP_DN + 105);
            ObjectCreate("MMLEVELS14", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("MMLEVELS14", "" + l_dbl2str_732 + "", 8, "Arial Bold", l_color_784);
            ObjectSet("MMLEVELS14", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS14", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS14", OBJPROP_YDISTANCE, Shift_UP_DN + 105);
         }
      }
   }
   return (0);
}